#include<stdio.h>
#include<sys/types.h>
#include<pwd.h>

void PW_get_name( char *buf, int bufsiz, int uid )
{
	struct passwd *pw;
	int i;
	char *q,*r;
	char b[80];

	bufsiz--;

	if( ( pw = getpwuid(uid) ) == NULL ){
		sprintf(b,"noname(UID=%-5.5d)",uid);
		strncpy(buf,b,bufsiz);
	}else{
		i = 0;
		q = buf;
		r = pw->pw_gecos;
		while( i < bufsiz && *r != '\0' && *r != ',' ){
			*q++ = iscntrl(*r) ? ' ' : *r;
			r++;
			i++;
		}
		if( i > 0 )
			*q = '\0';
		else
			strncpy(buf,pw->pw_name,bufsiz);
	}
}
